/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		EditorData.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	30.08.2001
// letzte nderung:	01.10.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	hilft dem Editor die Daten des TileSets in dessen GUI darzustellen			
/////////////////////////////////////////////////////////////////////////////////////

//includes
#include "EditorData.h"

// Methoden-Definitionen

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			EditorData::EditorData
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Konstruktor, initialisiert alle Member der Klasse
/////////////////////////////////////////////////////////////////////////////////////
EditorData::EditorData(void)
{
	m_iData[0]=-1;
	m_iData[1]=64;
	m_iData[2]=65;
	m_iData[3]=66;
	m_iData[4]=67;
	m_iData[5]=68;
	m_iData[6]=-999;
	m_iData[7]=-999;
	m_iData[8]=-999;
	m_iData[9]=-999;

	m_iData[10]=-1;
	m_iData[11]=69;
	m_iData[12]=70;
	m_iData[13]=71;
	m_iData[14]=72;
	m_iData[15]=73;
	m_iData[16]=-999;
	m_iData[17]=-999;
	m_iData[18]=-999;
	m_iData[19]=-999;

	m_iData[20]=-1;
	m_iData[21]=16;
	m_iData[22]=17;
	m_iData[23]=18;
	m_iData[24]=-999;
	m_iData[25]=-999;
	m_iData[26]=-999;
	m_iData[27]=-999;
	m_iData[28]=-999;
	m_iData[29]=-999;

	m_iData[30]=-1;
	m_iData[31]=80;
	m_iData[32]=81;
	m_iData[33]=82;
	m_iData[34]=83;
	m_iData[35]=84;
	m_iData[36]=85;
	m_iData[37]=86;
	m_iData[38]=87;
	m_iData[39]=88;

	m_iData[40]=-1;
	m_iData[41]=89;
	m_iData[42]=90;
	m_iData[43]=91;
	m_iData[44]=92;
	m_iData[45]=93;
	m_iData[46]=94;
	m_iData[47]=95;
	m_iData[48]=96;
	m_iData[49]=97;

	m_iData[50]=-999;
	m_iData[51]=-999;
	m_iData[52]=-999;
	m_iData[53]=-999;
	m_iData[54]=-999;
	m_iData[55]=-999;
	m_iData[56]=-999;
	m_iData[57]=-999;
	m_iData[58]=-999;
	m_iData[59]=-999;

	m_iData[60]=-999;
	m_iData[61]=-999;
	m_iData[62]=-999;
	m_iData[63]=-999;
	m_iData[64]=-999;
	m_iData[65]=-999;
	m_iData[66]=-999;
	m_iData[67]=-999;
	m_iData[68]=-999;
	m_iData[69]=-999;


	m_iData[70]=-999;
	m_iData[71]=-135;
	m_iData[72]=-136;
	m_iData[73]=-137;
	m_iData[74]=-134;
	m_iData[75]=-999;
	m_iData[76]=-999;
	m_iData[77]=-999;
	m_iData[78]=-999;
	m_iData[79]=-999;

	m_iData[80]=-999;
	m_iData[81]=-167;
	m_iData[82]=-168;
	m_iData[83]=-169;
	m_iData[84]=-166;
	m_iData[85]=-999;
	m_iData[86]=-999;
	m_iData[87]=-999;
	m_iData[88]=-999;
	m_iData[89]=-999;

	m_iData[90]=-999;
	m_iData[91]=-199;
	m_iData[92]=-200;
	m_iData[93]=-201;
	m_iData[94]=-198;
	m_iData[95]=-999;
	m_iData[96]=-999;
	m_iData[97]=-999;
	m_iData[98]=-999;
	m_iData[99]=-999;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			EditorData::getIcon
/////////////////////////////////////////////////////////////////////////////////////
// Info:	holt das Frame des TileSets, das Icon fr die Funktion sein soll
/////////////////////////////////////////////////////////////////////////////////////
int EditorData::getIcon(int iNr, int iSubNr)
{
	if (m_iData[iNr*10+iSubNr]==-999)
		return -1;
	else
		if (m_iData[iNr*10+iSubNr]<0)
			return -m_iData[iNr*10+iSubNr];
			else
			return m_iData[iNr*10+iSubNr];
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			EditorData::execute
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Fhrt die Funktion auf dem bergebenen Feld aus
/////////////////////////////////////////////////////////////////////////////////////
void EditorData::execute(Field* pfieldDest, int iX, int iY, int iNr, int iSubNr)
{
	int iFktNr=m_iData[iNr*10+iSubNr];

	if (iFktNr==-999)
		return;

	if (iFktNr>0 && iFktNr<256)
	{
		pfieldDest->setTile(iX,iY,iFktNr,true);
		return;
	}

	if (iFktNr>=-137 && iFktNr<=-134)
	{
		pfieldDest->getStartX(0,iX);
		pfieldDest->getStartY(0,iY);
		pfieldDest->getStartDirection(0,(-iFktNr)%4);
		return;
	}
	if (iFktNr>=-169 && iFktNr<=-166)
	{
		pfieldDest->getStartX(1,iX);
		pfieldDest->getStartY(1,iY);
		pfieldDest->getStartDirection(1,(-iFktNr)%4);
		return;
	}
	if (iFktNr>=-201 && iFktNr<=-198)
	{
		pfieldDest->getStartX(2,iX);
		pfieldDest->getStartY(2,iY);
		pfieldDest->getStartDirection(2,(-iFktNr)%4);
		return;
	}

	switch (iFktNr)
	{
	case -1:
		pfieldDest->setTile(iX,iY,rand()%16,true);
		break;
	}
	
}
/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	EditorData.cpp
/////////////////////////////////////////////////////////////////////////////////////
