/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XApplication.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			pHreak
//
// Erstelldatum:	23.08.2000
// letzte nderung:	11.03.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Die Klasse XApplication ermoeglicht die einfache Erstellung eines
//					Applikationsfensters
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000/2001 by x-treme
/////////////////////////////////////////////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XAPPLICATION_H
#define _XAPPLICATION_H

// includes
#include <windows.h>
#include "XLogging.h"

// Deklarationen

LRESULT CALLBACK wndProc(HWND	hWnd,
						 UINT	message,
						 WPARAM	wParam,
						 LPARAM	lParam);

// Klassen-Deklaration

class	XApplication
{
public:
	XApplication(void);
	
	HWND initialize(HINSTANCE	hInstance,
					LPCSTR		lpstrName,
					LPCSTR		lpstrTitle,
					WORD		wXAppIcon,
					int			nCmdShow = SW_SHOW);

	HWND getHWnd(void);

	LONG setWindowStyle(LONG	lWindowStyle);

protected:

private:
	HWND	m_hWnd;
};

#endif//_XAPPLICATION_H

class	XApplication;

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XApplication.h
/////////////////////////////////////////////////////////////////////////////////////